<?php

namespace Drupal\futurama\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Component\Serialization\Json;

/**
 * Provides a 'Futurama' block.
 *
 * @Block (
 *  id = "futurama_block",
 *  category = @Translation("Futurama"),
 *  admin_label = @Translation("Futurama"),
 *  module = "futurama"
 *  )
 */
class FuturamaBlock extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function build() {
    $language = \Drupal::languageManager()->getCurrentLanguage()->getId();
    $connection = \Drupal::database();
    $quote = $connection->select('futurama', 'f')
      ->fields('f', [
        'quote'
      ])
      ->orderRandom()
      ->range(0, 1)
      ->execute()
      ->fetchField();
    $url = 'https://api.mymemory.translated.net/get?q='.$quote.'&langpair=en|'.$language;
    $response = \Drupal::httpClient()->get($url);
    $data = Json::decode($response->getBody());
    return [
      '#type' => 'markup',
      '#markup' =>  $language != 'en' ? $data['responseData']['translatedText'] : $quote
    ];
  }

  /*
   * {inheritdoc}
   */
  public function getCacheMaxAge() {
    return 0;
  }

}
